!
!    IY
! ,    X  Y
subroutine DF43(Y, H, IY)
real, intent(in):: Y(:), H
real:: IY(:), S1, S2, S3, S4, S5
integer:: i, n
!begin
  n=size(Y)
  if(n==1) then
    IY(1)=0.0
  else if(n==2) then
    IY(2)=0.5*H*(Y(1)+Y(2))
    IY(1)=0.0
  else if(n==3) then
    S1=(1.0/12.0)*H*(5.0*Y(1)+8.0*Y(2)-Y(3))
    IY(3)=(1.0/3.0)*H*(Y(1)+4.0*Y(2)+Y(3))
    IY(2)=S1; IY(1)=0.0
  else if(n==4) then
    S1=(1.0/24.0)*H*(9.0*Y(1)+19.0*Y(2)-5.0*Y(3)+Y(4))
    S2=(1.0/3.0)*H*(Y(1)+4.0*Y(2)+Y(3))
    IY(4)=(3.0/8.0)*H*(Y(1)+3.0*(Y(2)+Y(3))+Y(4))
    IY(3)=S2; IY(2)=S1; IY(1)=0.0
  else
    S1=0.0
    S2=(1.0/720.0)*H*(251.0*Y(1)+646.0*Y(2)-    &
            264.0*Y(3)+106.0*Y(4)-19.0*Y(5))
    S3=(1.0/90.0)*H*(29.0*Y(1)+124.0*Y(2)+24.0*Y(3)+4.0*Y(4)-Y(5))
    S4=(1.0/80.0)*H*(27.0*Y(1)+102.0*Y(2)+72.0*Y(3)+42.0*Y(4)-3.0*Y(5))
    do i=5, n
      S5=S1+(2.0/45.0)*H*(7.0*(Y(i)+Y(i-4))+32.0*(Y(i-1)+Y(i-3))+    &
             12.0*Y(i-2))
      IY(i-4)=S1
      S1=S2; S2=S3; S3=S4; S4=S5
    end do
    IY(n-3)=S1
    IY(n-2)=S2
    IY(n-1)=S3
    IY(n)=S4
  end if
  return
end subroutine DF43
